#! /usr/bin/ruby

def prev_link(base)
  "<a href=\"#{base}-#{@prev_page}.html\" accesskey=\"p\"><img src=\"img/prev.png\" alt=\"([Alt]+[p])前ページ\"></a> "
end

def next_link(base)
  "<a href=\"#{base}-#{@next_page}.html\" accesskey=\"n\"><img src=\"img/next.png\" alt=\"([Alt]+[n])次ページ\"></a></div>"
end

pdffile = ARGV[0]
exit 1 unless File::stat(pdffile)
base = File::basename(pdffile,".pdf") 


tophtml = base + ".html"
reftxt = base + ".txt"

#
Fpage = 2
Lpage = 3

puts "Convert #{pdffile} to #{tophtml}"
puts "...."

exit 1 unless system("pdftohtml -c -enc UTF-8 #{pdffile}")
exit 1 unless system("pdftotext -f #{Fpage} -l #{Lpage} -enc UTF-8 #{pdffile} #{reftxt}")

p reftxt
f = File.open(reftxt)
refhtml = base + "-ref.html"
tmp = File.open(refhtml, "w")
tmp << "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">"
tmp << "<html>\n"
tmp << "<head>\n<link rel=\"stylesheet\" href=\"css/manual.css\" type=\"text/css\"></head>\n"
tmp << "<body>\n<pre>\n"
f.each {|line|
  line.gsub!(/\.\.+/,"__")
  line.gsub!(/(.[^ _]+)__ *([0-9]+)/,"<a href=\"#{base}-\\2.html\" target=\"contents\">\\1</a>..\\2\n")
  line.gsub!(/　　　　　　　2　\n/,"")
  line.gsub!(/　　　　　　　3　\n/,"")
  line.gsub!(/\f\n/,"")
  line.gsub!(/^ *\n$/,"")
  line.gsub!(/^ /,"")
  tmp << line
}
tmp << "</pre>\n</body>\n</html>\n"
tmp.close

puts "success!"

f = File.open(tophtml)
tmp = tophtml + ".tmp"
fs = File.open(tmp, "w")
f.each {|line|
  if line =~ /<FRAMESET cols=\"100\,\*\">/
    fs.print "<FRAMESET cols=\"200,*\">\n"
  elsif line =~ /<FRAME name=\"links\" src=\".*\">/
    fs.print "<FRAME name=\"links\" src=\"#{refhtml}\">\n"
  else
    fs.print line
  end
}
fs.close
f.close
File.rename(tophtml, tophtml +".bak")
File.rename(tmp, tophtml)

Dir.glob("#{base}*.html"){|file|
  if file =~ /#{base}-([0-9]+).html/
    @page = $1
    @prev_page = @page.to_i - 1
    @next_page = @page.to_i + 1
  end
  f = File.open(file)
  tmpfile = file + ".tmp"
  fs = File.open(tmpfile, "w")
  while s = f.gets
    if s =~ /^<\/DIV>/
      fs.print "<DIV style=\"position:absolute;top:0;left:0\">"
      fs.print prev_link(base)
      fs.print next_link(base)
      fs.print "\n"
      fs.print "<DIV style=\"position:absolute;top:1192;left:400\">"
      fs.print prev_link(base)
      fs.print next_link(base)
      fs.print "\n"
    else
      fs.print s
    end
  end
  File.rename(file, file +".bak")
  File.rename(tmpfile, file)
}

